// BSSDemoAppView.cpp : implementation of the CBSSDemoAppView class
//

#include "stdafx.h"
#include "BSSDemoApp.h"

#include "BSSDemoAppDoc.h"
#include "BSSDemoAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBSSDemoAppView

IMPLEMENT_DYNCREATE(CBSSDemoAppView, CScrollView)

BEGIN_MESSAGE_MAP(CBSSDemoAppView, CScrollView)
END_MESSAGE_MAP()

// CBSSDemoAppView construction/destruction

CBSSDemoAppView::CBSSDemoAppView()
{
	// TODO: add construction code here

}

CBSSDemoAppView::~CBSSDemoAppView()
{
}

BOOL CBSSDemoAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}


void CBSSDemoAppView::OnInitialUpdate()
{
    CScrollView::OnInitialUpdate();

    m_BitmapInfo.bmih.biSize          = 40;
    m_BitmapInfo.bmih.biWidth         = 0;
    m_BitmapInfo.bmih.biHeight        = 0;
    m_BitmapInfo.bmih.biPlanes        = 1;
    m_BitmapInfo.bmih.biBitCount      = 8;
    m_BitmapInfo.bmih.biCompression   = 0;
    m_BitmapInfo.bmih.biSizeImage     = 0;
    m_BitmapInfo.bmih.biXPelsPerMeter = 0;
    m_BitmapInfo.bmih.biYPelsPerMeter = 0;
    m_BitmapInfo.bmih.biClrUsed       = 0;
    m_BitmapInfo.bmih.biClrImportant  = 0;

    for( int n = 0; n < 256; n++ )
    {
        m_BitmapInfo.rgbPal[ n ].rgbRed   = n;
        m_BitmapInfo.rgbPal[ n ].rgbGreen = n;
        m_BitmapInfo.rgbPal[ n ].rgbBlue  = n;
        m_BitmapInfo.rgbPal[ n ].rgbReserved = 0;
    }

    SetScrollSizes( MM_TEXT, CSize( 0, 0 ) );
}


// CBSSDemoAppView drawing

void CBSSDemoAppView::OnDraw(CDC* pDC)
{
	CBSSDemoAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

    // Image parameters
    BYTE* pImgData   = pDoc->m_BitmapImg.GetDataPtr();
    int   nImgWidth  = pDoc->m_BitmapImg.GetWidth();
    int   nImgHeight = pDoc->m_BitmapImg.GetHeight();

    // Return if the image empty
    if( pImgData == NULL )
        return;

    // Parameters checking
    ASSERT( pImgData != NULL && nImgWidth > 0 && nImgHeight > 0 );

    // Fill fields of BITMAPINFO structure
    m_BitmapInfo.bmih.biWidth = nImgWidth;
    m_BitmapInfo.bmih.biHeight = -nImgHeight;

    // Maximum quality scaling
    ::SetStretchBltMode( pDC->GetSafeHdc(), HALFTONE );

    // Show the image
    ::StretchDIBits( pDC->GetSafeHdc(),
                     0,
                     0,
                     nImgWidth,
                     nImgHeight,
                     0,
                     0,
                     nImgWidth,
                     nImgHeight,
                     pImgData,
                     (LPBITMAPINFO)&m_BitmapInfo,
                     DIB_RGB_COLORS,
                     SRCCOPY );

    //
    // Show results of barcode reading
    //

    for( int n = 0; n < pDoc->m_BarcodeData.GetCount(); n++ )
    {
        int nCntrX = pDoc->m_BarcodeData[ n ].pntCenter.x;
        int nCntrY = pDoc->m_BarcodeData[ n ].pntCenter.y;

        CPen Pen( PS_SOLID, 20, RGB( 0, 255, 0 ) );
        pDC->SelectObject( &Pen );
        pDC->MoveTo( nCntrX, nCntrY );
        pDC->LineTo( nCntrX, nCntrY );

        const int iOffset = 500;
        CRect TextRect( nCntrX, nCntrY, nCntrX + iOffset, nCntrY + iOffset );
        pDC->SelectObject( GetStockObject( DEFAULT_GUI_FONT ) );
        pDC->DrawText( pDoc->m_BarcodeData[ n ].strContent,
                       &TextRect,
                       DT_LEFT );
    }

    SetScrollSizes( MM_TEXT, CSize( nImgWidth, nImgHeight ) );
}


// CBSSDemoAppView diagnostics

#ifdef _DEBUG
void CBSSDemoAppView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CBSSDemoAppView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CBSSDemoAppDoc* CBSSDemoAppView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBSSDemoAppDoc)));
	return (CBSSDemoAppDoc*)m_pDocument;
}
#endif //_DEBUG


// CBSSDemoAppView message handlers
